#pragma once


template <typename T>
class Property
{
private:
protected:
    T prop;
public:
    virtual ~Property() = default;
    virtual T& operator= (const T& f) { return prop = f;}
    virtual const T& operator() () const { return prop;}
    virtual explicit operator const T& () const { return prop;}
    [[nodiscard]] T Get() const { return prop;}
    T& Get() { return prop; }
    void Set(const T& new_val) { prop = new_val;}
};

